Base Distribution - Story # 40599

Work Package # 45013 (Resolved): Flexible plugin integration (TODO: Reviews)

Status: Resolved Priority: Should have
Author: Sebastian Kurfuerst Category: Content Rendering
Created: 2012-09-04 Assigned To: Marc Neuhaus
Updated: 2013-12-20 Due date: 2013-04-20
Subject: Include arbitrary Flow-Applications as Plugins

Description

As a content editor, | want to include an arbitrary Flow-Application inside a page.
Definition of done:
- FLOWS packages should run as plugin inside the frontend

- we use the Blog package as example
- the controllers and most of the views should be re-used

Subtasks:

Task # 44954: Provide a way to render PluginViews and PluginConfigurations in the Sidebar Resolved
Task # 46680: [FEATURE] Add ConfigurationProcessors for ContentTypes Resolved
Related issues:

related to TYPO3.Neos - Task # 25761: Enable Plugins to link/redirect to othe... Closed 2011-04-05

History

#1 - 2012-09-04 14:37 - Sebastian Kurfuerst

- Subject changed from As a content editor, | want to include the Blog inside a page to [DISCUSS] As a content editor, | want to include the Blog inside
a page

- Position deleted (1)

- Position set to 1

#2 - 2012-09-04 20:24 - Bastian Waidelich

Current Status

- Plugin TypoScript Object contains properties package, subpackage, controller & action
- action is the default action that is invoked when the plugin is called (if no PluginArguments specify other (sub)package, controller and/or action)
- There is currently no official way to link to Plugin actions on a different page (we currently use an AOP Aspect to solve this)

Ideas

- The Plugin TypoScript Object contains an (optional) PluginConfiguration and at least one PluginViewDefinitions

- The PluginSettings consists of arbitrary settings that are relevant to the plugin (e.g. max. number of posts per page)

- A PluginViewDefinition is configured globally (e.g. via YAML). It specifies (sub)package(s), controller(s) and action(s) that are part of a
PluginView (e.g. PostController->showAction, PostController->deleteAction for the Post Details PluginView). The first controller/action pair defines
the default. Later, a PluginViewConfiguration might also define (non)cacheable actions etc.

- The PluginView TypoScript Object references one PluginViewDefinition and a Plugin node (aka Master Plugin)

User Interface

When a plugin is inserted, the available PluginViews are displayed in the inspector panel:
Plugininspector_01.png

As soon as at least one plugin with multiple PluginViewDefinitions is available, the user can insert PluginView Content Objects. A PluginView has to
define Master Plugin node and the PluginViewDefinition it refers to:

PluginViewlInspector_01.png
http://git.typo3.org/FLOW3/Packages/TYPO3.Conference.git?a=blob;f=Classes/Aspect/TargetNodeAspect.php;hb=HEAD

When the user edits the Master Plugin instance again, the linked PluginViews are displayed in the inspector:
Plugininspector_02.png

#3 - 2012-09-04 20:45 - Bastian Waidelich

- File Plugininspector_01.png added

- File PluginViewlInspector_01.png added

- File Plugininspector_02.png added

#4 - 2012-09-04 22:33 - Sebastian Kurfuerst

Example for Form Builder: https://review.typo3.org/#/g/topic:formbuilder,n,z

#5 - 2012-09-07 09:23 - Sebastian Kurfuerst

- Subject changed from [DISCUSS] As a content editor, | want to include the Blog inside a page to As a content editor, | want to include the Blog inside
a page

- Position deleted (5)

- Position set to 5

#6 - 2012-09-07 09:47 - Bastian Waidelich

See https://review.typo3.org/#/c/14390/ for a first WIP

#7 - 2012-09-21 17:06 - Sebastian Kurfuerst

- Target version changed from Sprint 10 (1.0 TP1) to Sprint February 2013
- Position deleted (16)

- Position set to 4

#8 - 2012-10-11 11:13 - Sebastian Kurfuerst
- Position deleted (35)
- Position set to 2

#9 - 2013-01-29 14:18 - Robert Lemke
- Position deleted (18)
- Position set to 20

#10 - 2013-01-29 14:18 - Robert Lemke

- Target version deleted (Sprint February 2013)
- Position deleted (18)

- Position set to 72

#11 - 2013-01-29 15:27 - Sebastian Kurfuerst
- Category set to Content Rendering
- Assigned To set to Marc Neuhaus

- Target version set to Sprint February 2013

#12 - 2013-01-29 15:35 - Sebastian Kurfuerst

- Subject changed from As a content editor, | want to include the Blog inside a page to Include arbitrary Flow-Applications as Plugins

#13 - 2013-02-05 14:02 - Marc Neuhaus
https://review.typo3.org/#/q/topic:formbuilder,n,z
https://review.typo3.org/#/c/14390/

Did some Prototyping during the CodeSprint in Liibeck:

https://review.typo3.org/#/c/18007/
https://review.typo3.org/#/c/18008/
https://github.com/mneuhaus/TYPO3.Plugin.Blog/commit/632dda20170e502006f60ebe565d8f2838f7{693

#14 - 2013-03-18 15:05 - Marc Neuhaus
- Parent task set to #45013

#15 - 2013-04-04 11:48 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19513

#16 - 2013-04-04 13:37 - Gerrit Code Review

Patch set 7 for branch master has been pushed to the review server.

It is available at https://review.typo3.org/19513

#17 - 2013-04-04 14:09 - Gerrit Code Review

Patch set 8 for branch master has been pushed to the review server.
It is available at https://review.typo3.0rg/19513

#18 - 2013-04-11 00:21 - Gerrit Code Review

Patch set 9 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19513

#19 - 2013-04-11 16:19 - Gerrit Code Review

Patch set 10 for branch master has been pushed to the review server.

It is available at https://review.typo3.org/19513

#20 - 2013-04-12 17:03 - Gerrit Code Review

Patch set 11 for branch master has been pushed to the review server.
It is available at https://review.typo3.0rg/19513

#21 - 2013-04-15 10:52 - Gerrit Code Review

Patch set 12 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19513

#22 - 2013-06-06 12:12 - Gerrit Code Review
https://review.typo3.org/#/c/18007/
https://review.typo3.org/#/c/18008/
https://github.com/mneuhaus/TYPO3.Plugin.Blog/commit/632dda20170e502006f60ebe565d8f2838f7f693
https://review.typo3.org/19513
https://review.typo3.org/19513
https://review.typo3.org/19513
https://review.typo3.org/19513
https://review.typo3.org/19513
https://review.typo3.org/19513
https://review.typo3.org/19513

Patch set 13 for branch master has been pushed to the review server.

It is available at https://review.typo3.0rg/19513

#23 - 2013-12-20 17:37 - Bastian Waidelich
- Status changed from New to Resolved
